module Einutricional
  class MenuDietetico
    include Comparable
    attr_accessor :des, :alm, :cen, :alimentos, :tit, :dia_semana, :ingesta_min, :ingesta_max

    def initialize(dia_semana, &block)
      @dia_semana = dia_semana
      @des = Array.new
      @alm = Array.new
      @cen = Array.new
      if block_given?
        if block.arity == 1
          yield self
        else
          instance_eval(&block)
        end
      end
    end

    def titulo(t)
      @tit = t
    end

    def ingesta(datos)
      @ingesta_min = datos[:min]
      @ingesta_max = datos[:max]
    end

    def desayuno(des)
      des[:ve] = valor_energetico(des)
      @des << des
    end

    def almuerzo(alm)
      alm[:ve] = valor_energetico(alm)
      @alm << alm
    end

    def cena(cen)
      cen[:ve] = valor_energetico(cen)
      @cen << cen
    end

    def valor_energetico(hash)
      ve = 0
      ve += hash[:grasas] * 9
      ve += (hash[:hidratos] - hash[:azucares] - hash[:polialcoholes] - hash[:almidon]) * 4
      ve += hash[:azucares] * 4
      ve += hash[:polialcoholes] * 2.4
      ve += hash[:almidon] * 4
      ve += hash[:fibra] * 2
      ve += hash[:proteinas] * 4
      ve += hash[:sal] * 6
    end

    def <=>(other)
      valor_energetico_menu <=> other.valor_energetico_menu
    end

    def to_s
      # Barra superior de información
      print @tit.upcase.ljust(55), "COMPOSICIÓN NUTRICIONAL\n"
      print ' ' * 35,
            'Grasas'.ljust(9),
            'Hidratos'.ljust(11),
            'Proteínas'.ljust(12),
            'Fibra'.ljust(8),
            'Sal'.ljust(6),
            'Valor energético', "\n"
      puts '=' * 97
      ve = 0
      # Datos
      [@des, @alm, @cen].each do |momento_del_dia|
        unless momento_del_dia.empty?
          if momento_del_dia == @des
            puts '>> DESAYUNO'
          elsif momento_del_dia == @alm
            puts '>> ALMUERZO'
          else
            puts '>> CENA'
          end
        end

        momento_del_dia.each do |menu|
          ve += menu[:ve]
          print menu[:descripcion].ljust(35),
                menu[:grasas].to_s.ljust(9),
                menu[:hidratos].to_s.ljust(11),
                menu[:proteinas].to_s.ljust(12),
                menu[:fibra].to_s.ljust(8),
                menu[:sal].to_s.ljust(6),
                menu[:ve].round(0).to_s
          print "\n"
        end
      end
      puts '=' * 97
      print 'Total   '.rjust(81), ve
    end
  end
end



class Array
  def sorted?
    each_cons(2).all? {|left, right| left <= right}
  end

  def sort_for
    final = []
    final << shift
    for i in self
      final_index = 0
      while final_index < final.length
        if i <= final[final_index]
          final.insert(final_index, i)
          break
        elsif final_index == final.length - 1
          final.insert(final_index + 1, i)
          break
        end
        final_index += 1
      end
    end
    final
  end

  def sort_each
    final = []
    final << shift
    each do |i|
      final_index = 0
      while final_index < final.length
        if i <= final[final_index]
          final.insert(final_index, i)
          break
        elsif final_index == final.length - 1
          final.insert(final_index + 1, i)
          break
        end
        final_index += 1
      end
    end
    final
  end
end